scriptname boolTestC

struct testStruct
	bool b
	int i
	float f
	ObjectReference O
endStruct

Function testBoolStruct() Global
	testStruct structA = new testStruct
	testStruct structB = new testStruct
	
	structA.b = false
	structA.i = 0
	structA.f = 0
	structA.O = Game.GetForm(0x14) as ObjectReference ; PlayerRef
	
	structB.b = true
	structB.i = 1
	structB.f = 1
	structB.O = Game.GetForm(0x22B94) as ObjectReference ; some arbitrary rock somewhere
	
	bool bFalse = false
	bool bTrue = true
	
	int i0 = 0
	int i1 = 1
	
	float f0 = 0
	float f1 = 1
	
	ObjectReference PlayerRef = Game.GetForm(0x14) as ObjectReference
	ObjectReference Rock = Game.GetForm(0x22B94) as ObjectReference
	
	Debug.Trace("##############################")
	; these work properly
	Debug.Trace("structA: " + structA.b)
	Debug.Trace("structB: " + structB.b)
	Debug.Trace("structA.b || structB.b: " + (structA.b || structB.b))
	Debug.Trace("structB.b || structA.b: " + (structB.b || structA.b))
	Debug.Trace("false || (bTrue != bFalse): " + (false || (bTrue != bFalse)))
	Debug.Trace("false || (i0 != i1): " + (false || (i0 != i1)))
	Debug.Trace("false || (f0 != f1): " + (false || (f0 != f1)))
	Debug.Trace("false || (PlayerRef != Rock): " + (false || (PlayerRef != Rock)))
	Debug.Trace("false || (structA.i != structB.i): " + (false || (structA.i != structB.i)))
	Debug.Trace("false || (structA.f != structB.f): " + (false || (structA.f != structB.f)))
	Debug.Trace("false || (structA.O != structB.O): " + (false || (structA.O != structB.O)))
	
	; this one doesn't, with Caprica
	Debug.Trace("false || (structA.b != structB.b): " + (false || (structA.b != structB.b)))
	
	Debug.Trace("##############################")
EndFunction

;/
[04/17/2018 - 06:34:18PM] ##############################
[04/17/2018 - 06:34:18PM] structA: True
[04/17/2018 - 06:34:18PM] structB: False
[04/17/2018 - 06:34:18PM] structA.b || structB.b: True
[04/17/2018 - 06:34:18PM] structB.b || structA.b: True
[04/17/2018 - 06:34:18PM] false || (bTrue != bFalse): True
[04/17/2018 - 06:34:18PM] false || (structA.b != structB.b): True
[04/17/2018 - 06:34:18PM] ##############################
/;